module ram_ovp(
                nCS,
                nRD,
                nWR,
                HA,
                HD
                );

    input nCS, nRD, nWR;
    input [11:0] HA;
    inout [31:0] HD;

    //inout interface
    reg  [31:0]         HD_o;
    reg                 HD_en;
    //inout interface
    assign  HD = (HD_en==1'b1)?HD_o:31'bz;

    reg [31:0] ram_array [0:4095];

    always @(*)
    begin
        if (!nWR)
	begin
	    HD_en <= 1'b0;
	    ram_array[HA] <= HD;
	end
	else if (!nRD)
	begin
	    HD_en <= 1'b1;
	    HD_o <= ram_array[HA];
	end
	else
	begin
	    HD_en <= 1'b0;
	end
    end

endmodule

